﻿package {
	/*
	 * Bitmap Snapshot Animation SYSTEM
	 * .....................
	 * 
	 * Author: Gerry Creighton
	 * Copyright (c) The Spike Ranch 2008-2009
	 * http://www.thespikeranch.com
	 * 
	 * Licence Agreement
	 * 
	 * Permission is hereby granted, free of charge, to any person obtaining a copy
	 * of this software and associated documentation files (the "Software"), to deal
	 * in the Software without restriction, including without limitation the rights
	 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	 * copies of the Software, and to permit persons to whom the Software is
	 * furnished to do so, subject to the following conditions:
	 * 
	 * The above copyright notice and this permission notice shall be included in
	 * all copies or substantial portions of the Software.
	 * 
	 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	 * THE SOFTWARE.
	 */
	
	import flash.display.*;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import flash.events.*;
	import flash.filters.*;
	import flash.text.*;
	import PlayAgain_btn;
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.FilterShortcuts;
	import caurina.transitions.properties.CurveModifiers;

	[SWF(width='600', height='600', backgroundColor='#333333', frameRate='30')]
	
	public class BitmapSnapShot_v3 extends MovieClip{
		
		/* vs 3                   2-20-2010 9:26am EST 
		**@Author                 Gerry Creighton - www.thespikeranch.com - 9-2008- 2-20-2010 -  info@thespikeranch.com
		**@Param    total         This is the total number of snap shots to display. This gets calculated by cols X rows 
		**                        which are calculated by the snapSize.
		**@Param    count         This is a copy of the uint total but is used to count down for the animations. This must be
		**                        set after the total is set so do not move.
		**@Param    startx        This is the x position to place everything on the stage.
		**@Param    starty        This is the y position to place everything on the stage.
		**@Param    posx          This is the x position of the snap shots.
		**@Param    posy          This is the y position of the snap shots.
		**@Param    boxSize       This is the size of the main box that gets cut up. I used 400 since that was easily divisible.
		**@Param    destination   This is the direction that the boxes will animate off stage, top, bottom, right or left.
		**@Param    snapSize      This is the size of the cube that animates. Right now the size has to be a number that 400 can easily be dived by. 
		**                        I used the Tweener animation classes for the animations, you can reference the documentation for those classes
		**                        at the following location: http://code.google.com/p/tweener/
		*/

		
		private var Box:		MovieClip;
		private var clip:		MovieClip;
		private var tf:			TextField;
		private var animateTxt:	TextField;
		private var fmt:		TextFormat;
		private var play_btn:	PlayAgain_btn;
		private var dsfilter:	DropShadowFilter;
		private var destination:String;
		private var total:		uint;
		private var count:		uint;
		private var snapSize:	Number;
		private var boxSize:	Number;
		private var cols:		Number;
		private var rows:		Number;
		private var bw:			Number;
		private var bh:			Number;
		private var startx:		Number;
		private var starty:		Number;
		private var posx:		Number;
		private var posy:		Number;
		private var imgCount:	Number;
		private var str:		Number;
		private var wayArray:	Array;
		private var txtArray:	Array;
		private var pictures:	Array;
		
		
		
		public function BitmapSnapShot_v3(){
			//initialize filters to be used in Animate()
			FilterShortcuts.init();
			//initialize beziers used in Animate()
			CurveModifiers.init();
			init();
		}
		
		private function init():void{
			//
			destination = "bottom";//default starting destination for snaps to animate to.
			snapSize = 50;//snap shot width and height
			boxSize = 400;
			count = total;
			startx = 40;
			starty = 40;
			imgCount = 0;
			wayArray = ["bottom","top","right","left"];//array of destinations for the snaps to animate to.
			pictures = new Array();
			str = 0;
			//
			dsfilter = new DropShadowFilter(2,45,0x000000,.2,4,4,1,3,false,false,false);
			
			//set text to got through, I used three for this sample.
			var txtString:String = "FIRST STRING TO USE.\n Et vero, typicus decet praemitto, gemino suscipit saepius nutus oppeto. Abbas pertineo praesent ex feugiat capio blandit pecus acsi vel, letatio quidne qui. Accumsan validus sagaciter nulla secundum delenit. Os facilisis ne eu esse aliquip incassum defui defui causa iustum. Autem distineo minim ex paulatim consequat ludus importunus aliquam distineo duis duis fere pertineo multo. Ulciscor qui pertineo ad inhibeo nisl, refoveo sed lucidus letatio similis gilvus, abbas dignissim. Iustum et vicis hendrerit premo esse. Feugait feugait bene haero iusto te nibh vulputate ad at epulae, consequat.\n\n\n\n Et vero, typicus decet praemitto, gemino suscipit saepius nutus oppeto. Abbas pertineo praesent ex feugiat capio blandit pecus acsi vel, letatio quidne qui. Accumsan validus sagaciter nulla secundum delenit. Os facilisis ne eu esse aliquip incassum defui defui causa iustum. Autem distineo minim ex paulatim consequat ludus importunus aliquam distineo duis duis fere pertineo multo. Ulciscor qui pertineo ad inhibeo nisl, refoveo sed lucidus letatio similis gilvus, abbas dignissim. Iustum et vicis hendrerit premo esse. Feugait feugait bene haero iusto te nibh vulputate ad at epulae, consequat. ";
			var txtString1:String = "SECOND STRING TO USE.\n Et vero, typicus decet praemitto, gemino suscipit saepius nutus oppeto. Abbas pertineo praesent ex feugiat capio blandit pecus acsi vel, letatio quidne qui. Accumsan validus sagaciter nulla secundum delenit. Os facilisis ne eu esse aliquip incassum defui defui causa iustum. Autem distineo minim ex paulatim consequat ludus importunus aliquam distineo duis duis fere pertineo multo. Ulciscor qui pertineo ad inhibeo nisl, refoveo sed lucidus letatio similis gilvus, abbas dignissim. Iustum et vicis hendrerit premo esse. Feugait feugait bene haero iusto te nibh vulputate ad at epulae, consequat.";
			var txtString2:String = "THIRD STRING TO USE. \n Et vero, typicus decet praemitto, gemino suscipit saepius nutus oppeto. Abbas pertineo praesent ex feugiat capio blandit pecus acsi vel, letatio quidne qui. Accumsan validus sagaciter nulla secundum delenit. Os facilisis ne eu esse aliquip incassum defui defui causa iustum. Autem distineo minim ex paulatim consequat ludus importunus aliquam distineo duis duis fere pertineo multo. Ulciscor qui pertineo ad inhibeo nisl, refoveo sed lucidus letatio similis gilvus, abbas dignissim.\n\n This is the last txtString in the txtArray so it will now display the first string.";
			var txtString3:String = "FOURTH STRING TO USE. \n Abbas pertineo praesent ex feugiat capio blandit pecus acsi vel, letatio quidne qui. Accumsan validus sagaciter nulla secundum delenit. Os facilisis ne eu esse aliquip incassum defui defui causa iustum. Autem distineo minim ex paulatim consequat ludus importunus aliquam distineo duis duis fere pertineo multo. Ulciscor qui pertineo ad inhibeo nisl, refoveo sed lucidus letatio similis gilvus, abbas dignissim.\n\n This is the last txtString in the txtArray so it will now display the first string.";
			
			txtArray = [txtString,txtString1,txtString2,txtString3];
			
			//textfield and replay btn
			statusTxtField();
			addPlayBtn();
			//make the box and text field to chop up
			makeBox();
			addEventListener("update txt",setTxt);
		}
		
		private function statusTxtField():void{
			//This is a the txtField to display which direction the snaps will animate to.
			//format text
			fmt = new TextFormat();
			fmt.color = 0xFFFFFF;
			fmt.size = 14;
			fmt.font = "Helvetica";
			//display where the text will animate off stage
			animateTxt = new TextField();
			animateTxt.autoSize = TextFieldAutoSize.LEFT;
			animateTxt.defaultTextFormat = fmt;
			animateTxt.text = "Animate boxes off stage to the: "+wayArray[str];
			animateTxt.x = 10;
			animateTxt.y = 2;
			addChild(animateTxt);
		}
		
		private function addPlayBtn():void{
			//this button slides down after all of the snaps have animated off of the stage.
			//add replay btn
			play_btn = new PlayAgain_btn();
			play_btn.x = stage.stageWidth * 0.5 - play_btn.width * 0.5;
			play_btn.y = 0 - (play_btn.height+40);
			play_btn.buttonMode = true;
			play_btn.useHandCursor = true;
			play_btn.filters = [dsfilter];
			addChild(play_btn);
		}
		
		private function setTxt(e:Event):void{
			//
			if(str == 4){
				str = 0;
			}
			animateTxt.text = "Animate boxes off stage to the: "+wayArray[str];
		}
		private function makeBox():void{
			dispatchEvent(new Event("update txt"));
			//create a box mc and add a textField to it
			//textField
			tf = new TextField();
			tf.multiline = true;
			tf.wordWrap = true;
			tf.width = boxSize;
			tf.height = boxSize;
			tf.x = 2;
			tf.y = 2;
			//check current txtArray item and if it's the last one set the str value to 0 to display the first string.
			if(str == 4){
				str = 0;
			}
			tf.defaultTextFormat = fmt;
			//add greek text to fill most of the box, switch text from txtArray
			tf.text = txtArray[str];
		
			//box
			Box = new MovieClip();
			Box.graphics.beginFill(0x666666);
			Box.graphics.drawRoundRect(0,0,boxSize,boxSize,4);
			Box.graphics.endFill();
			Box.x = startx;
			Box.y = starty;
			Box.filters = [dsfilter];
			addChild(Box);
			Box.addChild(tf);
			Box.alpha = 0;
			bw = Box.width;
			bh = Box.height;
			setDimensions(Box);
			Tweener.addTween(Box,{alpha:1,time:2,transition:"easeoutexpo",onComplete:buildSnaps,onCompleteParams:[Box]});
			//
			destination = wayArray[str];
			str++;
		}


		private function setDimensions(img:MovieClip):void{
			
			cols = Math.round(bw/snapSize);
			rows = Math.round(bh/snapSize);
			total = cols * rows;
			count = total;
			
		}
		private function buildSnaps(mySource:MovieClip):void{
			//copy mc
			var bmpData1:BitmapData = new BitmapData( mySource.width, mySource.height, true, 0x00000000 );
			bmpData1.draw( mySource);

			//loop to make snapshots of image and position them
			for(var i:int = 0; i<total; i++){
				//loop to set x and y positions of squares
				posx = startx + (i % cols) * snapSize;
				posy = starty + (Math.floor(i / rows) * snapSize);
				//take snapshots of different parts of the mySource image
				var bmpData2:BitmapData = new BitmapData(snapSize,snapSize);
				bmpData2.copyPixels( bmpData1, new Rectangle(posx-startx,posy-starty,snapSize,snapSize), new Point(0,0));
				var bmp:Bitmap = new Bitmap(bmpData2);
				//add BitmapData to an mc
				var holder:MovieClip = new MovieClip();
				addChild(holder);
				holder.addChild(bmp);
				holder.x = posx;
				holder.y = posy;
				//
				pictures.push(holder);
		    }
			//remove original image to save memory
			bmpData1.dispose();
			removeChild(mySource);//remove original movieClip
			//animate snaps 
			Animate();
		}

		private function ranDom(min:Number, max:Number):Number {
			//generates a random number between min and max
			var randomNum:Number = Math.floor(Math.random() * (max - min )) + min;
			return randomNum;
		}
		//
		private function Animate():void {
			//trace("pictures length: "+pictures.length);
			if (count >= 0) {
				for(var i:uint = 0; i< pictures.length+1; i++){
					//add event listener to stop and clear animations
					pictures[0].addEventListener(Event.ENTER_FRAME,checkLoc);
					clip = pictures[count];
					var rot:Number = ranDom(-250, 250);
					//tween out with a delay between clips
					var cx:Number = ranDom(-400,stage.stageWidth+200);
					var cy:Number = ranDom(-200,stage.stageHeight+400);
					//animations
					switch(destination){
						case "right":
						Tweener.addTween(clip,{ x:stage.stageWidth+40,y:stage.stageHeight/2,_bezier:{x:startx+100, y:stage.stageHeight+100},time:1.5,delay: 0.015 * i,transition:"easeInOutBack", transitionParams:{overshoot:0.3}});
						break;
						case "left":
						Tweener.addTween(clip,{ x:-40,y:stage.stageHeight/2,_bezier:{x:startx+100, y:stage.stageHeight+100},time:1.5,delay: 0.015 * i,transition:"easeInOutBack", transitionParams:{overshoot:0.3}});
						break;
						case "bottom":
						Tweener.addTween(clip,{ y:stage.stageHeight+100,_bezier:{x:startx+100, y:stage.stageHeight+100},time:1.5,delay: 0.015 * i,transition:"easeInOutBack", transitionParams:{overshoot:0.3}});
						break;
						case "top":
						Tweener.addTween(clip,{ y:-100,_bezier:{x:stage.stageWidth * 0.5, y:stage.stageHeight+100},time:1.5,delay: 0.015 * i,transition:"easeInOutBack", transitionParams:{overshoot:0.3}});
						break;
					}
						
					Tweener.addTween(clip,{rotation:rot,time:5,delay: 0.012 * i,transition:"linear"});
					Tweener.addTween(clip,{alpha:0,time:1,delay: 0.015 * i,transition:"easeInQuart"});
					Tweener.addTween(clip,{_Blur_blurX:20,_Blur_blurY:20,time:.3,delay: 0.015 * i,transition:"linear"});
					//
					count--;
				}
				
			}
			
		}
        private function checkLoc(e:Event):void{
			//works to check location of last box animating to see 
			//if it's off stage-right.
			switch(destination){
				case "right":
			if(pictures[0].x >= stage.stageWidth){
				 pictures[0].removeEventListener(Event.ENTER_FRAME,checkLoc); 
				      AllDone();
				}
				break;
				
				case "left":
					if(pictures[0].x <= -40){
						 pictures[0].removeEventListener(Event.ENTER_FRAME,checkLoc); 
						      AllDone();
						}
						break;
				case "bottom":
					if(pictures[0].y >= stage.stageHeight+40){
						 pictures[0].removeEventListener(Event.ENTER_FRAME,checkLoc); 
						      AllDone();
						}
						break;
				case "top":
					if(pictures[0].y <= -40){
						 pictures[0].removeEventListener(Event.ENTER_FRAME,checkLoc); 
						      AllDone();
						}
						break;
					
		    }
		}
		private function AllDone():void{
			//reset everything and take fla to 2nd frame
			//trace("AllDone");
			count = 0;
			total = 0;
			rows = 0;
			cols = 0;
			pictures = [];//clear array
			//slide replay btn down
			Tweener.addTween(play_btn,{alpha:1,y:237,time:.5,transition:"easeoutexpo"});
 			play_btn.addEventListener(MouseEvent.CLICK,replay);

		}
		//
		private function replay(e:MouseEvent):void{
			//ldr.unload();
			FilterShortcuts.init();
			CurveModifiers.init();
			Tweener.addTween(play_btn,{alpha:1,y:0-40,time:.5,transition:"easeInOutBack", transitionParams:{overshoot:2.5},onComplete:makeBox});
		}
		
	}
	

}