package {
	
	/*
	 * Button code to create a rounded corner button with gradient fill.
	 * .....................
	 * 
	 * Author: Gerry Creighton
	 * Copyright (c) The Spike Ranch 2008
	 * http://www.thespikeranch.com
	 * 
	 * Licence Agreement
	 * 
	 * Permission is hereby granted, free of charge, to any person obtaining a copy
	 * of this software and associated documentation files (the "Software"), to deal
	 * in the Software without restriction, including without limitation the rights
	 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	 * copies of the Software, and to permit persons to whom the Software is
	 * furnished to do so, subject to the following conditions:
	 * 
	 * The above copyright notice and this permission notice shall be included in
	 * all copies or substantial portions of the Software.
	 * 
	 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	 * THE SOFTWARE.
	 */
	
	import flash.display.*;
	import flash.events.MouseEvent;
	import flash.text.*;
	import flash.geom.Matrix;
	
	public class PlayAgain_btn extends Sprite{
	
	private var rect:		Sprite;
	private var gradrect:	Sprite;
	private var tf:			TextField;
	private var fmt:		TextFormat;
	private var fmto:		TextFormat;
	
		public function PlayAgain_btn(){
			//create a rounded corner button
			init();
		}
		
		private function init():void{
			//
			buildLabel();
			drawButton();
		}
		
		private function buildLabel():void{
			//format for label
			fmt 		= new TextFormat();
			fmt.font 	= "Arial";
			fmt.size 	= 14;
			fmt.color 	= "0xFFFFFF";
			//text format for over state
			fmto 		= new TextFormat();
			fmto.font 	= "Arial";
			fmto.size 	= 14;
			fmto.color  = "0x000000";
			//textField for label
			tf 			= new TextField();
			tf.autoSize = TextFieldAutoSize.CENTER;
			tf.text 	= "Play Again";
			tf.setTextFormat(fmt);
			tf.x 		= 50 - tf.textWidth * 0.5;
			tf.y 		= 2;
			//
		}
		
		private function drawButton():void{
			//
			var fillType:String = GradientType.LINEAR;
			var colors:Array    = [0x000000, 0x000000];
			var alphas:Array    = [20, 0];
			var ratios:Array    = [0x00, 0xFF];
			var matr:Matrix     = new Matrix();
			matr.createGradientBox(100, 60, 300, 0, 0);
			var spreadMethod:String = SpreadMethod.PAD;
			gradrect = new Sprite();
			gradrect.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr, spreadMethod);
			gradrect.graphics.drawRoundRect(0,0,100,24,8);
			gradrect.graphics.endFill();
			//
			rect = new Sprite();
			rect.graphics.beginFill(0x666666);
			rect.graphics.drawRoundRect(0,0,100,24,8);
			rect.graphics.endFill();
			addChild(rect);
			rect.addChild(gradrect);
			//add label to rect
			rect.addChild(tf);
			rect.mouseChildren = false;
			rect.addEventListener(MouseEvent.MOUSE_OVER,_over);
			rect.addEventListener(MouseEvent.MOUSE_OUT,_out);
		}
		
		private function _over(e:MouseEvent):void{
			this.tf.setTextFormat(fmto);
			rect.graphics.beginFill(0xFFFFFF,.2);
			rect.graphics.drawRoundRect(0,0,100,24,8);
			rect.graphics.endFill();
		}
		private function _out(e:MouseEvent):void{
			this.tf.setTextFormat(fmt);
			rect.graphics.beginFill(0x666666);
			rect.graphics.drawRoundRect(0,0,100,24,8);
			rect.graphics.endFill();
		}
	}
}